/* Note: For chipKit Max users you must manually 
** connect SDA and SCL pins(20 and 21) to pins A4 and A5 of 
** IO Shield 
**
** Note: For chipKit Uno Users you must have Jumpers JP6 and JP8 
** set in the RG3 and RG2 positions
** 
** This example also checks the status of the Alert pin. Normally this
** could be used to send some information to an external device, but
** for this example it's just checked when we check the tempereture.
** to use this part of the example connect the A pin on header JP4
** to pin 2 on your ChipKit board.
** 
** Adapted for Chrome Serial by Tayeb Habib tayeb.habib@gmail.com
** Chrome serial example based on Renaun's myChromeBlink downloadable from:
** https://github.com/renaun/ArduinoExamples/tree/master/MyChromeArduinoBlink/MyChromeBlink
**
*/
int led = 26;
int lightOnLength = 1;
int blinkCount = 0;
#include <IOShieldTemp.h>
#include <Wire.h>
#define ALERT_PIN 2

void setup()
{
  Serial.begin(9600);
  pinMode(ALERT_PIN, INPUT); 
  pinMode (led, OUTPUT); 
  //Initialize Configuration register for oneshot with 11 bit
  //resolution
  IOShieldTemp.config(IOSHIELDTEMP_ONESHOT | IOSHIELDTEMP_RES11 | IOSHIELDTEMP_ALERTHIGH);
  
  //Set the range to bring the alert pin high if it's above 78F (25.5C), alert will stay
  //high until the temp drops below 75.2F (24C).
  IOShieldTemp.setTempLimit(IOShieldTemp.convFtoC(78)); // 78.0F ~ 25.5C
  IOShieldTemp.setTempHyst(24); // 75.2F ~ 24.0C
}

void loop() 
{
  float tempF, tempC;
  
  //Get Temperature in Celsius.
  tempC = IOShieldTemp.getTemp();
  
  // Convert the result to Fahrenheit.
  tempF = IOShieldTemp.convCtoF(tempC);
  Serial.print(1);
  Serial.print("a"); // My Command Values
  digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
  delay(lightOnLength * 1000);               // wait for a second
  Serial.print(0);
  Serial.print("a"); // My Command Values
  digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
  //Print Temperature to serial port
  // Serial.print(tempC);
  // Serial.print(",");
  // Serial.print(tempF);
  // Serial.print(",");
  // Serial.println("");
  delay(1000);  
  while (Serial.available() > 0) {
    lightOnLength = Serial.read();
      Serial.print(lightOnLength);
      Serial.print("b"); // My Command Values
    if (lightOnLength <= 0)
      lightOnLength = 1;
  }
  // serial send temperature value
  Serial.print(tempC);
  Serial.print("c"); // My Command Values
}
